// File:  graph1.cc
//
//   Example and the 2nd try at a Graphic Class
//
#include <grx.h>
#include <mousex.h>
#include <iostream.h>    
#include <Strclass.h>
#include <fstream.h>
#define FAIL 0
#define SUCESS 1
/*****************************************************************************
 *                                                                           *
 *  Graphic Class                                                            *
 *                                                                           *
 *      Functions                                                            *
 *              Graphic()   - Constructor initalizes graphics.               *
 *              ~Graphic()  - Destructor restores text mode.                 *
 *                                                                           *
 *              total_number_graphic_objects()  - returns the number of      *
 *                              graphic objects defined                      *
 *              scale()     - scale, returns the scale number. (not used yet)*
 *                                                                           *
 *              set_context(GrContext *new_context) - Sets a new graphic     *
 *                              context for the graphic object               *
 *              context()   - returns the graphic context of the object      *
 *              maxx()      - returns the max number of pixels in the x dir  *
 *              maxy()      - returns the max number of pixels in the y dir  *
 *              maxc()      - returns the max number of colors allowed       *
 *                                                                           *
 *****************************************************************************/

class Graphic
{       protected:

        static int initialized;
        static int ccount;
        static int MaxX,MaxY,MaxC;
        GrContext *ccontext;
        
        public:
        
        Graphic()
        {  if (initialized==0)
           {    GrSetMode(GR_biggest_noninterlaced_graphics); 
                initialized=1;
                MaxX=GrMaxX();
                MaxY=GrMaxY();
                MaxC=GrNumColors();
           }
           ccontext=NULL;
           ccount++;

        }
        ~Graphic()
        {  ccount--;
           if (ccount==0)
                GrSetMode(GR_default_text);
        }
        inline int total_number_graphic_objects() { return ccount; };
        inline void set_context(GrContext *new_context)
                { ccontext=new_context; };
        inline GrContext* context() {return ccontext; };
        inline int maxx() { return MaxX; };
        inline int maxy() { return MaxY; };
        inline int maxc() { return MaxC; };
};

int Graphic::ccount=0;
int Graphic::initialized=0;
int Graphic::MaxX=0, Graphic::MaxY=0, Graphic::MaxC=0;

class Box : public Graphic
{ 
	protected:
		int cc;  
		int xx1, yy1, xx2, yy2;
	public:
		Box() :
		  Graphic()
		{ xx1=0; yy1=0;
		  xx2=MaxX/12; yy2=MaxY/8;
		  cc=GrWhite(); 
		}
		Box(int x1, int y1, int x2, int y2, int c) :
		  Graphic()
		{ xx1=x1; yy1=y1; xx2=x2; yy2=y2; cc=c; }
		void cdraw()
		{ GrSetContext(ccontext);
		  GrBox(xx1,yy1,xx2,yy2,cc);
		}
		inline void fdraw() { GrBox(xx1,yy1,xx2,yy2,cc); };
		inline void set_c(int new_c) {cc=new_c;};
		inline int  c() { return cc; };

};
main ()
{ Box b;

  b.fdraw();
  getkey();
}
