// File:  box.cc
//
//   Example and the first try at a Graphic Class
//
#include <grx.h>
#include <mousex.h>
#include <iostream.h>    
#include <Strclass.h>
#include <fstream.h>
#define FAIL 0
#define SUCESS 1
//
// defaults to 1280 x 960 with 256 colors and in reality will
// mostly be less.
//

class Graphic
{       protected:

	static int initialized;
	static int ccount;
	static int MaxX,MaxY,MaxC;
	static float sscale;  
	// ratio of realpixel / MAX_Y pixels
	GrContext *ccontext;
	
	public:
	
	Graphic()
	{  if (initialized==0)
	   {    GrSetMode(GR_biggest_noninterlaced_graphics); 
		initialized=1;
		MaxX=GrMaxX();
		MaxY=GrMaxY();
		MaxC=GrNumColors();
		ccontext=NULL;
	   }
	   ccount++;

	}
	~Graphic()
	{  ccount--;
	   if (ccount==0)
		GrSetMode(GR_default_text);
	}
	inline int total_number_graphic_objects() { return ccount; };
	inline float scale() { return sscale; };
	inline void set_context(GrContext *new_context)
		{ ccontext=new_context; };
	inline GrContext* context() {return ccontext; };
};
int Graphic::ccount=0;
int Graphic::initialized=0;
int Graphic::MaxX=0, Graphic::MaxY=0, Graphic::MaxC=0;
float Graphic::sscale=0;
struct color_info
{       String color_name;
	int color_number;
} ;
class Color_Table : public Graphic
{
	private :
	   color_info c_table[ 255 ] ;
	   int entries;
	public :
	   Color_Table():
	       Graphic(),
	       entries(0)
	   { c_table[entries].color_name="WHITE";
	     c_table[entries].color_number=GrWhite();
	     entries++;
	     c_table[entries].color_name="BLACK";
	     c_table[entries].color_number=GrBlack();
	     entries++;
	     for (int i=entries ; i<GrNumColors(); i++)
	     {   c_table[i].color_name="";
		 c_table[i].color_number=-1;
	     }
	   }
	   int alloc(int r, int g, int b, String name) 
	   { 
	     if (entries>=MaxC) 
		return FAIL;
	     c_table[entries].color_number=GrAllocColor(r,g,b);
	     c_table[entries].color_name=name;
	     entries++;
	     return SUCESS;
	   }
	   int c(String name)
	   {    for (int i=0 ; i<entries; i++)
		{  if (c_table[i].color_name==name)
		     return c_table[i].color_number;
		}
		return -1;
	   }
};
//
//      >> Operator to read Color Tables.
//
istream& operator>> (istream& s, Color_Table& c)
{       String name,brace;
	int r,g,b;

	s >> name;
	if (name!="Color_Table")
		return s;
	s >> brace;
	if (brace!="{")
		return s;
	do 
	{ s >> r >> g >> b >> name;
	  c.alloc(r,g,b,name);
	} while (name!="END");
	s >> brace;
	return s;
}

class Box : public Graphic
{ 
	protected:
		int cc;  
		int xx1, yy1, xx2, yy2;
	public:
		friend ostream& operator<< (ostream& s, const Box& b) ;
		Box() :
		  Graphic()
		{ xx1=0; yy1=0;
		  xx2=MaxX/12; yy2=MaxY/8;
		  cc=GrWhite(); 
		}
		Box(int x1, int y1, int x2, int y2, int c) :
		  Graphic()
		{ xx1=x1; yy1=y1; xx2=x2; yy2=y2; cc=c; }
		void cdraw()
		{ GrSetContext(ccontext);
		  GrBox(xx1,yy1,xx2,yy2,cc);
		}
		inline void fdraw() { GrBox(xx1,yy1,xx2,yy2,cc); };
		inline void set_c(int new_c) {cc=new_c;};
		inline int  c() { return cc; };

};
//
//      << Operator to print Box in a readable manner.
//
ostream& operator<< (ostream& s, const Box& b)
{       return s << "Box " << endl 
		 << b.xx1 << b.yy1 << b.xx2 
		 << b.yy2 << b.cc << endl;
}
Color_Table c;  
main ()
{ Box b;
  ifstream color_file("COLOR.DAT");

  if (!color_file) 
  { c.alloc(120,0,0,"RED");
    b.set_c(c.c("RED"));
    b.fdraw();
  }
  else
  { color_file>>c;
    b.set_c(c.c("BLUE"));
    b.fdraw();
  }
  getkey();
}
