// File:  COLSEL.H
//
//   Example and the 2nd try at a color selector
//
#include "graphic.h"
#include <stdio.h>
#include <conio.h>
#define Font_Hight 16
#define Font_Width 8

class Color_Selector : public Box
{
	protected:
		GrFBoxColors c1,c2;
		int color_cell;
		int r,g,b,w;
		int xx3,yy3,xx4,yy4;
		int bg;
		int top_left1x, top_left2x, top_left3x;
		int top_lefty;
	public :
		void setup();
		Color_Selector() : 
		  Box    (MaxX/10,   // x1
			  MaxY/8,    // y1
			  MaxX/8*2,  // x2
			  MaxY/8*2,  // y2
			  GrWhite())     // c
		  {  r=g=b=125;
		     this.setup(); 
		  }
		Color_Selector(int x1, int y1, int x2, int y2, int c) :
		  Box(x1,y1,x2,y2,c)
		  {  r=g=b=125;
		     this.setup(); 
		  }
		void cdraw();
		void fdraw() { this.cdraw(); };
		void add_x(int added_x);                        
		void add_y(int added_y);
		void add_r(int added_r);
		void add_g(int added_g);
		void add_b(int added_b);
		inline void cset() {GrSetColor(color_cell,r,g,b);}
		void adjust();
};
void Color_Selector::setup() 
  {  w=(xx2-xx1)/20;  // Thickness of borders 1/20 
		      // of width of box.
     // Make Sure that lower half is large enough to 
     // hold characters to display color values.
     // using 2*Font_Hight by 13*Font_Width
     // as min comforable space.
     xx3=xx1;
     yy3=yy2+w;
     yy4=yy3+2*Font_Hight;
     xx4=xx3+13*Font_Width;
     if (xx4<xx2) 
	xx4=xx2;   // use xx2 if its bigger

     // Top Left x corner of diplayed text fields
     top_left1x=xx1+Font_Width;
     top_left2x=top_left1x+Font_Width*4;
     top_left3x=top_left2x+Font_Width*4;

     // Top Left y is same for all 3 fields.
     top_lefty=yy3+Font_Hight/2;

     // Top Half of Color Selector Colors
     color_cell=GrAllocCell(); // variable color cell
     c1.fbx_intcolor=color_cell;  
     GrSetColor(color_cell,r,g,b);  // set the color
     c1.fbx_topcolor=cc;    c1.fbx_rightcolor=cc;
     c1.fbx_bottomcolor=cc; c1.fbx_leftcolor=cc;

     // Bottom Half of Color Selector Colors
     c2.fbx_intcolor=GrBlack();
     bg=c2.fbx_intcolor;
     c2.fbx_topcolor=cc;    c2.fbx_rightcolor=cc;
     c2.fbx_bottomcolor=cc; c2.fbx_leftcolor=cc;
  }
  
void Color_Selector::cdraw()
  { char ntext[4];  // Text Buffer for printing color values
		   // on graphic screen.
    GrSetContext(ccontext);
    GrFramedBox(xx1,yy1,xx2,yy2,w,&c1); // Draw Top Half
    GrFramedBox(xx3,yy3,xx4,yy4,w,&c2); // Bottom Half
    sprintf(ntext,"%d\0",r);  // Red index
    GrTextXY(top_left1x,top_lefty,ntext,cc,bg);
    sprintf(ntext,"%d",g);  // Green index
    GrTextXY(top_left2x,top_lefty,ntext,cc,bg);
    sprintf(ntext,"%d",b);  // Blue index
    GrTextXY(top_left3x,top_lefty,ntext,cc,bg);
  }
void Color_Selector::add_x(int added_x)
  {  xx2+=added_x;
     this.setup();
     this.cdraw();
  }
void Color_Selector::add_y(int added_y)
  {  yy2+=added_y;
     this.setup();
     this.cdraw();
  }
void Color_Selector::add_r(int added_r)
  {  r+=added_r;
     if(r>255) r=255;    // enforce limits
     if(r<0) r=0;
     this.cset();
     this.cdraw();
  }
void Color_Selector::add_g(int added_g)
  {  g+=added_g;
     if(g>255) g=255;    // enforce limits
     if(g<0) g=0;
     this.cset();
     this.cdraw();
  }
void Color_Selector::add_b(int added_b)
  {  b+=added_b;
     if(b>255) b=255;    // enforce limits
     if(b<0) b=0;
     this.cset();
     this.cdraw();
  }
void Color_Selector::adjust()
  {     char c;
	c= getch();
	while (c!=(char) 27)
	{       // Red adjust keys
		if (c=='q') this.add_r(10);
		if (c=='w') this.add_r(1);
		if (c=='e') this.add_r(-1);
		if (c=='r') this.add_r(-10);
		// Green adjust keys
		if (c=='a') this.add_g(10);
		if (c=='s') this.add_g(1);
		if (c=='d') this.add_g(-1);
		if (c=='f') this.add_g(-10);
		// Blue adjust keys
		if (c=='z') this.add_b(10);
		if (c=='x') this.add_b(1);
		if (c=='c') this.add_b(-1);
		if (c=='v') this.add_b(-10);
		c=getch();
	}
  }

