//  Win5
//
//   Try 5 at windowing : Framed, Filled window & 
//                        Title Bar with
//                        Appropreate sized bitmapped
//                        text.
//                        Using Prefered Color Setup.
//                        Resizeable & Moveable
#include "graphic.h"
#include "debug.h"
Color_Table color_table;
struct Win_Colors
{       int background;
	int window;
	int window_frame;
	int char_in_win;
	int scroll_bar;
	int menu;
	int char_in_menu;
	int active_title_bar;
	int inact_title_bar;
	int char_act_title;
	int char_ina_title;
	int popup_win;
	int char_in_popup;
	int message_window;
	int char_in_message;
	int button_face;
	int button_text;
	int button_shadow;
} Wcp;
//
//      >> Operator to read Win Colors.
//
istream& operator>> (istream& s, Win_Colors& Wcp)
{       String name,brace,color;

	s >> name;
	if (name!="Win_Colors")
		return s;
	s >> brace;
	if (brace!="{")
		return s;
do 
{ s >> name >> color;
  if (name=="background"     ) Wcp.background     =color_table.c(color);
  if (name=="window"         ) Wcp.window         =color_table.c(color);
  if (name=="window_frame"   ) Wcp.window_frame   =color_table.c(color);
  if (name=="char_in_win"    ) Wcp.char_in_win    =color_table.c(color);
  if (name=="scroll_bar"     ) Wcp.scroll_bar     =color_table.c(color);
  if (name=="menu"           ) Wcp.menu           =color_table.c(color);
  if (name=="char_in_menu"   ) Wcp.char_in_menu   =color_table.c(color);
  if (name=="active_title_bar") Wcp.active_title_bar=color_table.c(color);
  if (name=="inact_title_bar") Wcp.inact_title_bar=color_table.c(color);
  if (name=="char_act_title" ) Wcp.char_act_title =color_table.c(color);
  if (name=="char_ina_title" ) Wcp.char_ina_title =color_table.c(color);
  if (name=="popup_win"      ) Wcp.popup_win      =color_table.c(color);
  if (name=="char_in_popup"  ) Wcp.char_in_popup  =color_table.c(color);
  if (name=="message_window" ) Wcp.message_window =color_table.c(color);
  if (name=="char_in_message") Wcp.char_in_message=color_table.c(color);
  if (name=="button_face"    ) Wcp.button_face    =color_table.c(color);
  if (name=="button_text"    ) Wcp.button_text    =color_table.c(color);
  if (name=="button_shadow"  ) Wcp.button_shadow  =color_table.c(color);
} while (color!="END");
	s >> brace;
	return s;
}

class Title_Bar : public Box
{
	protected: 
		int m_x,m_y;     // m=message
		String message;
		int len;
		String family;
		GrTextOption op;
		GrFont *font;
	public:
		Title_Bar(char *m,char *fam) :
			message(m),
			family(fam),
			Box()  
		{  
		   len=message.length();
		   cc=Wcp.active_title_bar;  // Set Bar Color.
		}
		void cdraw()
		{  
		   GrSetContext(ccontext);
		   GrFilledBox(xx1,yy1,xx2,yy2,cc);
		   GrDrawString((char*)message,len,
				m_x, m_y, &op );
		}
		void fdraw()
		{  GrFilledBox(xx1,yy1,xx2,yy2,cc);
		   GrDrawString((char*)message,len,
				m_x, m_y, &op );
		}
		void locate(int x1,int y1,int x2,int y2)
		{  // Given windows coordinates change
		   // title bar coordiantes to match.
		   // and load appropreate font.
		   int max_width,max_height;
		   int tot_width,tot_height;
		   
		   xx1=x1+1;
		   yy1=y1+1;
		   xx2=x2-1;
		   yy2=y1+1+MaxY/30;
		   
		   max_width=(xx2-xx1)/len;
		   max_height=yy2-yy1;
		   if(NULL==GrFindBestFont(max_width,
				  max_height,
				  0,
				  (char *) family,
				  &op )
		      )
		       mess_i("Null returned from GrFind",0);
		   op.txo_fgcolor.v=Wcp.char_act_title;
		   op.txo_bgcolor.v=Wcp.active_title_bar;
		   tot_width=GrStringWidth((char *)message,len,&op);
		   tot_height=GrStringHeight((char *)message,len,&op);
		   m_x=xx1+(xx2-xx1-tot_width)/2;
		   m_y=yy1+(yy2-yy1-tot_height)/2;
		}
};
class Window : public Box
{       protected :
		Title_Bar title;
		GrFBoxColors win_frame_c;
	public :
	Window () :
	  Box(MaxX/4,
	      MaxY/4,
	      MaxX/4*3,
	      MaxY/4*3,
	      Wcp.window_frame),
	  title("Test Title Bar","times")
	{    win_frame_c.fbx_intcolor=Wcp.window;
	     win_frame_c.fbx_topcolor=Wcp.window_frame;
	     win_frame_c.fbx_bottomcolor=Wcp.window_frame;
	     win_frame_c.fbx_leftcolor=Wcp.window_frame;
	     win_frame_c.fbx_rightcolor=Wcp.window_frame;
	}           
	void cdraw()
	{  GrClearScreen(Wcp.background);
	   GrFramedBox(xx1,yy1,xx2,yy2,MaxX/100,&win_frame_c);
	   title.locate(xx1,yy1,xx2,yy2);
	   title.cdraw();
	}
	void fdraw()
	{   this.cdraw();
	}
	void resize()
	{ char c;
	  c= getch();
	  while (c!=(char) 27)
	  {     // X adjust keys
		if (c=='q') this.add_x(10);
		if (c=='w') this.add_x(1);
		if (c=='e') this.add_x(-1);
		if (c=='r') this.add_x(-10);
		// Y adjust keys
		if (c=='a') this.add_y(10);
		if (c=='s') this.add_y(1);
		if (c=='d') this.add_y(-1);
		if (c=='f') this.add_y(-10);
		c=getch();
	  }
	}
	void add_xx1(int x);
	void add_yy1(int y);
	void move()
	{ char c;
	  c= getch();
	  while (c!=(char) 27)
	  {     // X adjust keys
		if (c=='q') this.add_xx1(10);
		if (c=='w') this.add_xx1(1);
		if (c=='e') this.add_xx1(-1);
		if (c=='r') this.add_xx1(-10);
		// Y adjust keys
		if (c=='a') this.add_yy1(10);
		if (c=='s') this.add_yy1(1);
		if (c=='d') this.add_yy1(-1);
		if (c=='f') this.add_yy1(-10);
		c=getch();
	  }
	}
};
void Window::add_xx1(int x)
{       xx1+=x;
	xx2+=x;
	this.fdraw();
}
void Window::add_yy1(int y)
{       yy1+=y;
	yy2+=y;
	this.fdraw();
}
main()
{     ifstream color_file("COLOR.DAT");
      ifstream pref_colors("PCOL.DAT");
      if (color_file && pref_colors)
      {
	 color_file >> color_table;
	 pref_colors>> Wcp;
	 GrSetFontPath("C:\\DJGPP\\CONTRIB\\LIBGRX\\FONTS\\");  
	 Window win;
	 win.cdraw();
	 win.resize();
	 win.move();
	 getkey();
      }
}
