//  File : Thing.H
//
//  A more sophisicated Thing object.
//
#ifndef __THING_H
#define __THING_H
#include <Strclass.h>
#include "POSITION.H"
#include "DIMEN.H"
#define SUCESS 1
#define FAIL 0
//
// The state_of_life enumeration type will help to answer the
//  question "Is this Thing alive?"
//
//
enum    state_of_life
	{       none,
		alive,
		dead,
		inanimate
	};
//
// An over loaded operator to print in letters the state_of_life, as opposed to 
//  relatively hard to understand numbers.
//
ostream& operator<< (ostream& s, const state_of_life& life)
{       switch (life)
	{       case none   : return s << "none";
		case alive  : return s << "alive";
		case dead   : return s << "dead";
		case inanimate : return s << "inanimate";
	}
    
}

#define FAIL 0
#define SUCCESS 1
class Thing
{
	// Protected data and functions
   protected:
	String           nname;
	Position         oon_screen,
			 oon_map;
	Dimention        ssize;
	state_of_life    llife;

   public:

	// Constructor
	Thing() :
		nname(),
		oon_screen(0,0,no_stage,screen),
		oon_map(0,0,no_stage,map),
		ssize()
		{}
		

	//Public data and functions
	
	friend ostream& operator<< (ostream& s, const Thing& t);

	virtual void display(Position screen_position)
	{    cout<<"No display function"<<endl;
	}

	// Name functions
	virtual void set_name(String new_name)
	{       
		nname = new_name;
	}
	virtual String get_name()
	{       return nname;
	}

	// Position Functions
	virtual Position get_on_screen_position()
	{       return oon_screen;
	}
	virtual Position get_on_map_position()
	{       return oon_map;
	}
	virtual int set_position(Position new_position,
			 Position screen_position);


	// Dimention Functions
	virtual Dimention get_dimention()
	{       return ssize;
	}
	virtual int set_dimention(Dimention source)
	{       ssize=source;
		return SUCESS;
	}

	// Life Functions
	virtual state_of_life get_life()
	{       return llife;
	}
	virtual int set_life(state_of_life source)
	{       llife=source;
		return SUCESS;
	}
};
// set_position
//
//    This function sets the positions (on map and on screen) of 
//    this "Thing" from a single position given of either type.
//

Thing::set_position(Position new_position,
		    Position screen_position)
{       
	// this set of if statement uses the w element of the new_positon
	// to check if the new position is given as a screen positon or
	// as a map position to apply the correct values to the position
	// of this "Thing".
	//

       if (new_position.w()== no_where )
	{       return(FAIL); // Invalid Position
	}
       if (new_position.w()== screen )
	{       oon_screen=new_position;
		oon_map.zero();
		oon_map+=new_position;
		oon_map+=screen_position;
		oon_map.set_z(oon_screen.z());
	}
       if (new_position.w()== map )
	{       oon_map=new_position;
		oon_screen.zero();
		oon_screen+=new_position;
		oon_screen-=screen_position;
		oon_screen.set_z(oon_map.z());
	}
       return (SUCESS);
}
// Notice that the following new overloaded operator
//    is not in the class body.  C++ requires that it
//    be separate although by making it a friend the
//    function can access private variables like ssize,
//    and oon_screen.
//
ostream& operator<< (ostream& s, const Thing& t)
{       return s << "This "<<t.nname<<" is " <<t.llife<<" and has " << endl
		<<  t.ssize          << endl
		<<  "   and :"       << endl
		<<  t.oon_screen     << endl
		<<  t.oon_map        << endl;
}
#endif
