//
//  File: wmouse.cc
//
//      1st try at a mouse with window
//
#include "window.h"
class Button  : public Box
{
       protected :
          GrFBoxColors button_c;
          int len;
          String llable,family;
          int l_x,l_y;     // l=lable
          GrTextOption op;
          MouseEvent evt;
          GrFont *font;
       public:
          Button *next;
          int active,display;

          Button(int x1,int y1,int x2,int y2,String lable,
                        int disp=YES,int acti=YES,String fam="times") : 
            Box(x1, y1, x2, y2, Wcp.button_shadow),
            llable(lable),
            family(fam)
          { display=disp;
            active=acti;
            next=NULL;
            len=llable.length();
            if (len>0)
               this.locate(x1,y1,x2,y2);
            if (display==YES)
                this.upcolor();
          }
          void upcolor()
          { if (display==NO) return;
            button_c.fbx_intcolor=Wcp.button_face;
            button_c.fbx_topcolor=Wcp.button_highlight;
            button_c.fbx_bottomcolor=Wcp.button_shadow;
            button_c.fbx_leftcolor=Wcp.button_highlight;
            button_c.fbx_rightcolor=Wcp.button_shadow;           
            this.fdraw();
          }
          void set_active(int acti=YES)
          {  if (active==acti)
                return;
             active=acti;
             this.fdraw();   
          }
          void downcolor()
          { if (display==NO) return;
            button_c.fbx_intcolor=Wcp.button_face;
            button_c.fbx_topcolor=Wcp.button_face;
            button_c.fbx_bottomcolor=Wcp.button_face;
            button_c.fbx_leftcolor=Wcp.button_face;
            button_c.fbx_rightcolor=Wcp.button_face;           
            this.fdraw();
          }
          void fdraw()
          {  if (display==NO) return;
             GrFramedBox(xx1,yy1,xx2,yy2,MaxX/100,&button_c);
             if (len>0)
                GrDrawString((char*)llable,len,
                                l_x, l_y, &op );
          }
          virtual void press()
          {  if (active==NO) return;
             this.downcolor();
             MouseGetEvent((M_BUTTON_UP ),&evt);
             this.upcolor();
             this.action();
          }
          virtual void action()
          {  // do nothing.
          }
          void locate(int x1,int y1,int x2,int y2)
          {  // Given button coordinates change
             // lable coordiantes to match.
             // and load appropreate font.
             int max_width,max_height;
             int tot_width,tot_height;
                                      
             max_width=(xx2-xx1)/len;
             max_height=yy2-yy1;
             if(NULL==GrFindBestFont(max_width,
                           max_height,
                           0,
                           (char *)family,
                           &op )
               )
               mess_i("Null from GrFind in button",0);
             op.txo_fgcolor.v=Wcp.button_text;
             op.txo_bgcolor.v=Wcp.button_face;
             tot_width=GrStringWidth((char *)llable,len,&op);
             tot_height=GrStringHeight((char *)llable,len,&op);
             l_x=xx1+(xx2-xx1-tot_width)/2;
             l_y=yy1+(yy2-yy1-tot_height)/2;
          }
};
class ButtonList  
{
        Button *head;

        public:

        ButtonList() { head=NULL; } 
        void insert(Button *newb)
        {   newb->next=head;
            head=newb;
        }
        Button *remove_first()
        {   Button *tmp;
            if (head==NULL)
               return 0;
            tmp=head;
            head=tmp->next;
            return(tmp);
        }
        Button *find(int x,int y)
        {       Button *tmp;
                for (tmp=head; tmp!=NULL ; tmp=tmp->next)
                {  if ( tmp->x1()<x && x<tmp->x2() &&
                        tmp->y1()<y && y<tmp->y2() )
                        return (tmp);
                }
                return NULL;
        }
        void press(int x,int y)
        {       Button *tmp=this.find(x,y);
                if (tmp==NULL)
                        return;
                tmp->press();
                
        }
};
class Pointer
{       public :
                MouseEvent evt; 
                int ok;
                Pointer ()
                {ok=FAIL;
                 if (MouseDetect())
                 {      MouseEventMode(1);
                        MouseInit();
                        MouseSetColors(color_table.c("RED"),
                                color_table.c("BLACK"));
                        MouseDisplayCursor();
                        MouseSetCursorMode(M_CUR_NORMAL);
                        MouseEventEnable(0,1);
                        ok=SUCESS;
                 }
                }
                ~Pointer()
                {
                 if (MouseDetect())
                        MouseUnInit();
                }
};
int initialize()
{
      ifstream color_file("COLOR.DAT");
      ifstream pref_colors("PCOL.DAT");

      if (color_file && pref_colors)
      {    color_file >> color_table;
           pref_colors>> Wcp;
           GrSetFontPath(".\\");  
           return SUCESS;
      }
      return FAIL;
}
main()
{     
      char buffer[30];
     
      if (initialize()==SUCESS)
      {  Pointer mouse;
         if (mouse.ok==SUCESS)
         {       
           int bgc=Wcp.background;
           Twindow win("Test Window","cour",20,20);
           win.cdraw();
           win.print("Press a button\n");
           Button c(100,250,200,350,"No"),
                b(100,100,200,200,"Ok");
           ButtonList a;
           a.insert(&b);
           a.insert(&c);
           for (int i=15 ;i>0;i--)
           {   MouseGetEvent(( M_BUTTON_DOWN ),&mouse.evt);
               a.press(mouse.evt.x,mouse.evt.y);
               sprintf(buffer,"Count = %d\n",i);
               win.print(buffer);
           }
         }
      }
}
